﻿using ff14bot;
using ff14bot.Enums;
using ff14bot.Managers;
using ff14bot.Objects;
using TreeSharp;

namespace Gladiator
{
    public static class Casting
    {
        public static Action StopCasting
        {
            get { return new Action(r => Actionmanager.StopCasting()); }
        }

        public static Composite Cast(string spellName)
        {
            var action = new Action(r => Actionmanager.DoAction(spellName, Core.Player.CurrentTarget));
            return new Decorator(req => CastValid(spellName), action);
        }

        public static bool CastValid(string spellName)
        {
            var target = Core.Player.CurrentTarget;

            if (target == null) { return false; }

            SpellData spellData;
            if (!Actionmanager.CurrentActions.TryGetValue(spellName, out spellData)) { return false; }
            if (!Actionmanager.CanCast(spellName, target)) { return false; }

            return true;
        }

        public static bool WasLastSpell(string name)
        {
            return Actionmanager.LastSpell.Name == name;
        }
    }
}