﻿using System.Collections.Generic;
using System.Linq;
using ff14bot.Managers;
using ff14bot.Objects;

namespace Gladiator
{
    public static class Combat
    {
        public static int EnemiesNearTarget(float range)
        {
            return Targeting.Target == null ? 0 : Enemies.Count(c => Targeting.IsNearTarget(c, range));
        }

        public static IEnumerable<Character> Enemies
        {
            get
            {
                return GameObjectManager.GetObjectsOfType<BattleCharacter>()
                    .Where(c => !c.IsDead && c.CanAttack && c.InCombat);
            }
        }

        public static IEnumerable<Character> Allies
        {
            get
            {
                return GameObjectManager.GetObjectsOfType<Character>()
                    .Where(c => c.InCombat && !c.CanAttack && !c.IsDead);
            }
        }
    }
}